%{
#include "rumd/ConfigurationMetaData.h"
#include "rumd/ConfigurationWriterReader.h"
#include "rumd/IHS_OutputManager.h"
  %}


%rename(assign) *::operator=; // to remove warnings about operator=
%include "rumd/LogLin.h"

%include "rumd/EnergiesMetaData.h"

%include "rumd/ConfigurationMetaData.h"

class ConfigurationWriterReader {
public:
  ConfigurationMetaData metaData;
  ConfigurationWriterReader();
  void Write(Sample* S, const std::string& filename, const std::string& mode);
  void Read(Sample* S, const std::string& filename);
};


%nodefaultctor LogLinOutputManager;

class LogLinOutputManager {};

class EnergiesOutputManager : public LogLinOutputManager {
 public:
  EnergiesOutputManager(Sample *S, const std::string& outputDirectory,
			const std::string& baseFilename);
  void AddExternalCalculator(ExternalCalculator* calc);
  void RemoveExternalCalculator(ExternalCalculator* calc);
  void Set(const std::string &key, bool val);
};


class IHS_OutputManager : public LogLinOutputManager {
 public:
  IHS_OutputManager(Sample* S, float timeStep);
  void SetMaximumNumberIterations(unsigned int set_max_num_iter);
  void SetForceTolerance(float max_force);
  void SetIHSLinearWriteInterval(unsigned long int writeInterval);
  void SetIHSLogLinParams(unsigned int base, unsigned int maxInterval);
};
